angular.module('myApp', ['smart-table'])
    .controller('MainController', ['$scope','tableService', function ($scope,tableService) {

        var vm = this;
        
        vm.getTableData = function (tableState) {
            var pageSize=tableState.pagination.number;
            var pageNum=Math.floor(tableState.pagination.start / tableState.pagination.number) + 1;

            tableService.getTableData(pageSize,pageNum).success(function (response) {
                if (response.success) {
                    vm.tableDataList = response.entity.list;
                    vm.total = response.entity.total;
                    tableState.pagination.numberOfPages = response.entity.pages;
                } else {
                    vm.tableDataList = [];
                    vm.total = 0;
                }
            }).error(function (error) {
                console.log(error);
            });
        };

    }]);