angular.module('smart-table').run(['$templateCache', function ($templateCache) {
    $templateCache.put('assets/lib/smart-table/custom-page.html', [
        '<nav ng-if="pages.length >= 2">',
        '<ul class="pagination">',
        '<li><a style="float:left;" ng-click="selectPage(1)">首页</a></li>',
        '<li class="previous" ng-class={"disabled":currentPage===1} ng-disabled="currentPage===1"><a ng-click="currentPage===1 || selectPage(currentPage - 1)">上一页</a></li>',
        '<li ng-repeat="page in pages" ng-class="{active: page==currentPage}"><a href="javascript: void(0);" ', 'ng-click="selectPage(page)">{{page}}</a></li>',
        '<li style="float:right;"><span><page-select></page-select> / {{numPages}}页</span></li>',
        '<li><a style="float:right;" ng-click="selectPage(numPages)">尾页</a></li>',
        '<li class="next" ng-class="{disabled:currentPage>=numPages}" ng-disabled="currentPage>=numPages"><a ng-click="currentPage===numPages || selectPage(currentPage + 1)" >下一页</a></li>',
        '</ul>',
        '</nav>'
    ].join(''));

    $templateCache.put('assets/lib/smart-table/st-idp.html',
        [
            '<div  ng-if="stTotalCount>0"  class="pull-left">{{getFromItemIndex()}}-{{getToItemIndex()}}/{{stTotalCount}}条&nbsp;&nbsp;每页显示<select  ng-model="stItemsByPage" ng-options="item for item in [10,25,50,100]" ng-change="displayLengthChange(stItemsByPage)"></select>条</div>',
            '<div ng-show="stTotalCount>stItemsByPage" st-pagination   st-items-by-page="stItemsByPage" st-template="assets/lib/smart-table/custom-page.html" class="pull-right"></div> '
        ].join(''));
}])

    //表格刷新的时候，只要st-search-watch监听的对象发生改变，就触发pipe方法
    .directive('stSearchWatch', function () {
        return {
            restrict: 'A',
            require: '^^stTable',
            scope: {
                stSearchWatch: '='
            },
            link: function (scope, element, attrs, ctrl) {
                scope.$watch('stSearchWatch', function (newValue, oldValue) {
                    if (newValue !== oldValue) {
                        var tableState = ctrl.tableState();
                        tableState.pagination.start = 0;
                        ctrl.pipe();
                    }
                }, true);
            }
        };
    })
    .directive('stIdp', ['stConfig', function (stConfig) {
        //display length
        //information
        //pagination
        return {
            restrict: 'AE',
            require: '^stTable',
            scope: {
                stTotalCount: '='
            },
            templateUrl: 'assets/lib/smart-table/st-idp.html',
            link: function (scope, element, attrs, ctrl) {
                scope.currentPage = 1;
                scope.numPages = 0;
                
                scope.stItemsByPage = scope.stItemsByPage ? +(scope.stItemsByPage) : stConfig.pagination.itemsByPage;

                //页码改变时，修改当前页码数，和总页数。
                scope.$watch(function () {
                    return ctrl.tableState().pagination;
                }, function () {
                    scope.currentPage = Math.floor(ctrl.tableState().pagination.start / ctrl.tableState().pagination.number) + 1;
                    scope.numPages = ctrl.tableState().pagination.numberOfPages;
                }, true);


                scope.getFromItemIndex = function () {
                    if (scope.stTotalCount === 0) {
                        return 0;
                    } else {
                        return (scope.currentPage - 1) * scope.stItemsByPage + 1;
                    }

                };

                scope.getToItemIndex = function () {
                    if (scope.stTotalCount === 0) {
                        return 0;

                    } else {
                        return scope.currentPage >= scope.numPages ? scope.stTotalCount : scope.currentPage * scope.stItemsByPage;
                    }
                };

                scope.displayLengthChange = function (stItemsByPage) {
                    scope.stItemsByPage = stItemsByPage
                };

            }
        };
    }])

    .directive('pageSelect', function () {
        return {
            restrict: 'E',
            template: '<input type="text" class="select-page" ng-model="inputPage" ng-change="selectPage(inputPage)">',
            link: function (scope, element, attrs) {
                scope.$watch('currentPage', function (c) {
                    scope.inputPage = c;
                });
            }
        }
    });

